; 

      .686p                     ; create 32 bit code
      .mmx
      .xmm
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include imgbtn.inc        ; local includes for this file

.code

start:
      invoke InitCommonControls

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandle, NULL)
      mov CommandLine, rv(GetCommandLine)
      mov hIcon,       rv(LoadIcon,hInstance,500)
      mov hCursor,     rv(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"Image_Button_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                            hIcon,hCursor,COLOR_BTNFACE+1

    mov Wwd, 400
    mov Wht, 550
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPED or WS_SYSMENU,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

    invoke BmpButton,hWnd,50,50,575,576,900
;    fn MessageBox,hWnd,str$(eax),"Button 1",MB_OK

    invoke BmpButton,hWnd,50,120,577,578,901
;    fn MessageBox,hWnd,str$(eax),"Button 2",MB_OK

    invoke BmpButton,hWnd,50,190,579,580,902
;    fn MessageBox,hWnd,str$(eax),"Button 3",MB_OK

    invoke BmpButton,hWnd,50,260,581,582,903
;    fn MessageBox,hWnd,str$(eax),"Button 4",MB_OK

    invoke BmpButton,hWnd,50,330,583,584,904
;    fn MessageBox,hWnd,str$(eax),"Button 5",MB_OK

    invoke BmpButton,hWnd,50,400,585,586,905
;    fn MessageBox,hWnd,str$(eax),"Button 6",MB_OK

    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    switch uMsg
      case WM_COMMAND
        switch wParam
          case 900
            fn MessageBox,hWin,str$(eax),"Title",MB_OK
          case 901
            fn MessageBox,hWin,str$(eax),"Title",MB_OK
          case 902
            fn MessageBox,hWin,str$(eax),"Title",MB_OK
          case 903
            fn MessageBox,hWin,str$(eax),"Title",MB_OK
          case 904
            fn MessageBox,hWin,str$(eax),"Title",MB_OK
          case 905
          ; ----------------------------------------------
          ; note the use of PostMessage here, required due
          ; to a timing issue with the custom control
          ; ----------------------------------------------
            invoke PostMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
        endsw

      case WM_CLOSE

      case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start
